﻿@model Blum.Web.Models.ConsultaViewModel
@{
    ViewData["Title"] = "Produtos";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h1>Pesquisar</h1>

<form method="get" asp-controller="Consulta" asp-action="Produtos">
    <div class="input-group mb-3">
        <input asp-for="Buscar" type="text" class="form-control" placeholder="Produto" aria-label="Buscar" aria-describedby="button-addon2">
        <div class="input-group-append">
            <button class="btn btn-outline-primary" type="submit" id="button-addon2">Buscar</button>
        </div>
    </div>
</form>

<form>
    <div class="table-responsive">
        <div>
            <table class="table align-items-center table-hover table-secondary" id="tabelaProdutos">
                <thead class="bg-blue text-white">
                    <tr>
                        <th scope="col">Info</th>
                        <th style="cursor: pointer" onclick="sortTable(1)">Produto</th>
                        <th scope="col" class="sort" data-sort="preco">Preço</th>
                        <th scope="col" class="sort" data-sort="status">Status</th>
                        <th scope="col" class="sort" data-sort="mercado">Mercado</th>
                        <th scope="col"></th>
                    </tr>
                </thead>
                <tbody class="list">
                    @if (Model.Produtos != null)
                    {
                        @foreach (var item in Model.Produtos)
                        {
                            <tr class="header expand border-light">
                                <td>
                                    <a class="btn btn-sm btn-icon text-light" href="#" id="@Html.DisplayFor(p => item.Id)" onclick="mostrarDados(@Html.DisplayFor(p => item.Id));" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                        <i id="@Html.DisplayFor(p => item.Id)arrow" class="produto ni ni-bold-down"></i>
                                    </a>
                                </td>
                                <td>
                                    @Html.DisplayFor(p => item.Nome)
                                </td>
                                <td class="budget">
                                    <span class="status">R$ @Html.DisplayFor(p => item.Preco)</span>
                                </td>
                                <td>
                                    <span class="badge badge-dot mr-4">
                                        <i class="bg-success"></i>
                                        <span class="status"> @Html.DisplayFor(p => item.Situacao)</span>
                                    </span>
                                </td>

                                <td>
                                    @Html.DisplayFor(p => item.Mercados.Nome)
                                </td>
                                <td class="text-right">
                                    <div class="dropdown">
                                        <a class="btn btn-sm btn-icon-only text-light" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                            <i class="fas fa-ellipsis-v"></i>
                                        </a>
                                        <div class="dropdown-menu dropdown-menu-right dropdown-menu-arrow">
                                            <a class="dropdown-item" href="#">Action</a>
                                            <a class="dropdown-item" href="#">Another action</a>
                                            <a class="dropdown-item" href="#">Something else here</a>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                            <tr style="display: none" id="@Html.DisplayFor(p => item.Id)tr" class="border-light">
                                <td colspan="6">
                                    <div class="row mt-1">
                                        <div class="col mt-1">
                                            <h5>Preços atuais</h5>
                                            <p class="description">
                                                Valor normal: R$ @Html.DisplayFor(p => item.PrecoOriginal)
                                            </p>
                                            <p class="description">
                                                Promocional: R$ @Html.DisplayFor(p => item.Preco)
                                            </p>
                                            <p class="description">
                                                Exclusivo: R$ @Html.DisplayFor(p => item.PrecoExclusivo)
                                            </p>
                                        </div>
                                        <div class="col mt-1">
                                            <h5>Preços anteriores</h5>
                                            <p class="description">
                                                Valor normal: R$ @Html.DisplayFor(p => item.UltimoPrecoOriginal)
                                            </p>
                                            <p class="description">
                                                Promocional: R$ @Html.DisplayFor(p => item.UltimoPreco)
                                            </p>
                                            <p class="description">
                                                Exclusivo: R$ @Html.DisplayFor(p => item.UltimoPrecoExclusivo)
                                            </p>
                                        </div>
                                        <div class="col mt-1">
                                            <h5>Outros</h5>
                                            <p class="description">
                                                Popularidade: @Html.DisplayFor(p => item.Popularidade)
                                            </p>
                                            <p class="description">
                                                Última alterção: @Html.DisplayFor(p => item.DataAlteracao)
                                            </p>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                        }
                    }
                </tbody>
            </table>
        </div>
    </div>
</form>

@section scripts {
    <script type="text/javascript">
        function mostrarDados(id) {
            var element = '#' + id;

            $(element + 'tr').slideToggle(100);

            if ($(element + 'arrow').hasClass("ni ni-bold-down")) {
                $(element + 'arrow').removeClass("ni ni-bold-down");
                $(element + 'arrow').addClass("ni ni-bold-up");
            } else {
                $(element + 'arrow').removeClass("ni ni-bold-up");
                $(element + 'arrow').addClass("ni ni-bold-down");
            }

        };
    </script>

    <script type="text/javascript">
        function sortTable(n) {
            var table, rows, switching, i, x, y, shouldSwitch, dir, switchcount, rownum, nextrow = 0;
            table = document.getElementById("tabelaProdutos");
            switching = true;
            // Set the sorting direction to ascending:
            dir = "asc";
            /* Make a loop that will continue until
            no switching has been done: */
            while (switching) {
                // Start by saying: no switching is done:
                switching = false;
                rownum = 0;
                rows = table.rows;
                /* Loop through all table rows (except the
                first, which contains table headers): */
                for (i = 1; i < (rows.length - 1); i++) {
                    // Start by saying there should be no switching:
                    shouldSwitch = false;
                    /* Get the two elements you want to compare,
                    one from current row and one from the next: */
                    if (rownum == 0) {
                        rownum = 1;
                        nextrow = 3;
                    } else {
                        rownum = i
                        nextrow = i + 2;
                    }

                    x = rows[rownum].getElementsByTagName("TD")[n];
                    y = rows[nextrow].getElementsByTagName("TD")[n];
                    /* Check if the two rows should switch place,
                    based on the direction, asc or desc: */
                    if (dir == "asc") {
                        if (x.innerHTML.toLowerCase() > y.innerHTML.toLowerCase()) {
                            // If so, mark as a switch and break the loop:
                            shouldSwitch = true;
                            break;
                        }
                    } else if (dir == "desc") {
                        if (x.innerHTML.toLowerCase() < y.innerHTML.toLowerCase()) {
                            // If so, mark as a switch and break the loop:
                            shouldSwitch = true;
                            break;
                        }
                    }
                }



                if (shouldSwitch) {
                    /* If a switch has been marked, make the switch
                    and mark that a switch has been done: */
                    rows[rownum].parentNode.insertBefore(rows[nextrow], rows[rownum]);
                    rows[rownum].parentNode.insertBefore(rows[rownum +1], rows[nextrow +1]);
                    switching = true;
                    // Each time a switch is done, increase this count by 1:
                    switchcount++;
                } else {
                    /* If no switching has been done AND the direction is "asc",
                    set the direction to "desc" and run the while loop again. */
                    if (switchcount == 0 && dir == "asc") {
                        dir = "desc";
                        switching = true;
                    }
                }
                switching = false;
                rownum = 0;
            }
        }
    </script>
}